package common

// NFT defines NFT object baseon erc721
type NFT struct {
	TokenID   string `json:"tokenId"`
	Owner     string `json:"owner"`
	Approved  string `json:"approved"`
	TokenURI  string `json:"tokenURI"`
	Times     int
	Timestamp string
}

type Approval struct {
	Owner    string `json:"owner"`
	Operator string `json:"operator"`
	Approved bool   `json:"approved"`
}

// MetadataJSON represents erc 721 metadata with json format.
type Metadata struct {
	Name        string              `json:"name"`
	Description string              `json:"description"`
	Category    int                 `json:"category"`
	Type        string              `json:"type"` // image, audio, 3d, video
	Hash        string              `json:"hash"`
	URL         string              `json:"url"`
	Properties  map[string]Property `json:"properties,omitempty"`
}

// Property represents k-v property in metadata
type Property struct {
	Value       string `json:"value"`
	Description string `json:"description"`
}

type ComposableInf struct {
	TokenID               string              `json:"tokenId"`
	ChildCollectionIndexs []string            `json:"childCollectionIndexs"`
	ChildTokenIDs         map[string][]string `json:"childTokenIDs"` // map childCollectionIndex to the array of childTokenIDs
	MaxCount              uint64              `json:"maxCount"`
}

type ParentInf struct {
	ParentOwner           string `json:"parentOwner"`
	ParentCollectionIndex string `json:"parentCollectionIndex"`
	ParentTokenID         string `json:"parentTokenID"`
}
