package common

import (
	"errors"
	"strconv"
)

// TokenID defines nft token
type TokenID uint64

// TokenIndex defines index of token with TokenMaxLen bytes.
type TokenIndex [TokenLen]byte

var InvalidTokenID TokenID = 0

func (t TokenID) IsValid() bool {
	return t >= InvalidTokenID
}
func (t TokenID) String() string {
	return strconv.FormatUint(uint64(t), 10)
}

func ConvTokenStr(token string) (TokenID, error) {
	uToken, err := strconv.ParseUint(token, 10, 64)
	if err != nil {
		return InvalidTokenID, errors.New("token id should be positive integer[0-2^64)")
	}
	return TokenID(uToken), nil
}
