package common

import (
	"errors"
	"strings"

	contractapi "git.huawei.com/poissonsearch/wienerchain/contract/docker-container/contract-go/contractapi"
)

type DCMAPI func(stub contractapi.ContractStub, args [][]byte) ([]byte, error)

func CreateCompositeKey(keyType string, attr []string) (string, error) {
	if keyType == "" || len(keyType) == 0 {
		return "", errors.New("keyType error")
	}
	keyType = compositeKeyNamespace + keyType
	if len(attr) != 0 {
		keyType = keyType + string(MinUnicodeValue) + strings.Join(attr, string(MinUnicodeValue))
	}
	return keyType + string(MinUnicodeValue), nil
}
