package contract

import (
	"fmt"
	"git.huawei.com/evidence/evidence"

	"git.huawei.com/evidence/common"
	"git.huawei.com/evidence/identity"

	contractapi "git.huawei.com/poissonsearch/wienerchain/contract/docker-container/contract-go/contractapi"
)

var funcMap map[string]common.DCMAPI

// Collection represents ntf collection to support publish different ntf in one contract
type DCMContract struct {
}

func NewSmartContract() contractapi.Contract {
	return &DCMContract{}
}

func init() {
	funcMap = make(map[string]common.DCMAPI)
	evidence.LoadEvidenceApi(funcMap)
	identity.LoadDIDAPI(funcMap)
}

func (c *DCMContract) Init(stub contractapi.ContractStub) ([]byte, error) {
	return nil, nil
}

func (c *DCMContract) Invoke(stub contractapi.ContractStub) ([]byte, error) {
	funcName := stub.FuncName()
	args := stub.Parameters()

	if api := funcMap[funcName]; api != nil {
		return api(stub, args)
	}
	return nil, fmt.Errorf("unsupported function {%s}", funcName)
}
